unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, clGoogleCalendar, clTcpClient, clHttp, clWebDav;

type
  TForm1 = class(TForm)
    btnCreate: TButton;
    memResponse: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    edtEmail: TEdit;
    edtPassword: TEdit;
    Label3: TLabel;
    edtTitle: TEdit;
    Label4: TLabel;
    edtContent: TEdit;
    Label5: TLabel;
    edtWhere: TEdit;
    Label6: TLabel;
    edtStartTime: TEdit;
    Label7: TLabel;
    edtEndTime: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    edtAuthID: TEdit;
    clGoogleCalendar1: TclGoogleCalendar;
    btnDelete: TButton;
    btnRetrieve: TButton;
    btnUpdate: TButton;
    btnLogin: TButton;
    btnGetEventList: TButton;
    cbEventId: TComboBox;
    procedure btnCreateClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnRetrieveClick(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
    procedure btnLoginClick(Sender: TObject);
    procedure btnGetEventListClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnCreateClick(Sender: TObject);
begin
  try
    clGoogleCalendar1.EventTitle := edtTitle.Text;
    clGoogleCalendar1.EventContent := edtContent.Text;
    clGoogleCalendar1.EventWhere := edtWhere.Text;
    clGoogleCalendar1.EventStartTime := edtStartTime.Text;
    clGoogleCalendar1.EventEndTime := edtEndTime.Text;

    cbEventId.Items.Add(clGoogleCalendar1.CreateEvent());
    cbEventId.ItemIndex := cbEventId.Items.Count - 1;

    memResponse.Lines.Add('---Create Event completed---');
  except
    on E: EclHttpError do
    begin
      memResponse.Lines.Add(E.ResponseText);
      raise;
    end;
  end;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
var
  ind: Integer;
begin
  try
    clGoogleCalendar1.DeleteEvent(cbEventId.Text);
    ind := cbEventId.Items.IndexOf(cbEventId.Text);
    cbEventId.Items.Delete(ind);

    cbEventId.Text := '';
    edtTitle.Text := '';
    edtContent.Text := '';
    edtWhere.Text := '';
    edtStartTime.Text := '';
    edtEndTime.Text := '';

    memResponse.Lines.Add('---Delete Event completed---');
  except
    on E: EclHttpError do
    begin
      memResponse.Lines.Add(E.ResponseText);
      raise;
    end;
  end;
end;

procedure TForm1.btnGetEventListClick(Sender: TObject);
begin
  clGoogleCalendar1.GetEventList(cbEventId.Items);
  if (cbEventId.Items.Count > 0) then
  begin
    cbEventId.ItemIndex := 0;
  end;
  
  memResponse.Lines.Add('---Event List Retrieved---');
end;

procedure TForm1.btnLoginClick(Sender: TObject);
begin
  if (clGoogleCalendar1.AuthID <> '') then Exit;

  clGoogleCalendar1.UserAgent := 'CleverComponents-InetSuiteSample-78';
  clGoogleCalendar1.Email := edtEmail.Text;
  clGoogleCalendar1.Password := edtPassword.Text;

  edtAuthID.Text := clGoogleCalendar1.Login();
end;

procedure TForm1.btnRetrieveClick(Sender: TObject);
begin
  try
    clGoogleCalendar1.RetrieveEvent(cbEventId.Text);

    edtTitle.Text := clGoogleCalendar1.EventTitle;
    edtContent.Text := clGoogleCalendar1.EventContent;
    edtWhere.Text := clGoogleCalendar1.EventWhere;
    edtStartTime.Text := clGoogleCalendar1.EventStartTime;
    edtEndTime.Text := clGoogleCalendar1.EventEndTime;

    memResponse.Lines.Add('---Retrieve Event completed---');
  except
    on E: EclHttpError do
    begin
      memResponse.Lines.Add(E.ResponseText);
      raise;
    end;
  end;
end;

procedure TForm1.btnUpdateClick(Sender: TObject);
begin
  try
    clGoogleCalendar1.EventTitle := edtTitle.Text;
    clGoogleCalendar1.EventContent := edtContent.Text;
    clGoogleCalendar1.EventWhere := edtWhere.Text;
    clGoogleCalendar1.EventStartTime := edtStartTime.Text;
    clGoogleCalendar1.EventEndTime := edtEndTime.Text;

    clGoogleCalendar1.UpdateEvent();

    memResponse.Lines.Add('---Update Event completed---');
  except
    on E: EclHttpError do
    begin
      memResponse.Lines.Add(E.ResponseText);
      raise;
    end;
  end;
end;

end.
